<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<link href="../yui/build/container/assets/skins/sam/container.css" rel="stylesheet" type="text/css"
      media="all"/>
<script type="text/javascript" src="../carbon/global-params.js" type="text/javascript"></script>
<script type="text/javascript" src="../yui/build/utilities/utilities.js"></script>

<fmt:bundle basename="org.wso2.carbon.wsdlconverter.ui.i18n.Resources">
<carbon:breadcrumb 
		label="wsdlConverter"
		resourceBundle="org.wso2.carbon.wsdlconverter.ui.i18n.Resources"
		topPage="true" 
		request="<%=request%>" />

    <%
        String backendServerURL = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
                session);
    %>

    <script type="text/javascript">

        wso2.wsf.Util.initURLs();

        var frondendURL = wso2.wsf.Util.getServerURL() + "/";

        function submitUsingFile() {
            var wsdlFile = document.getElementById("wsdlFile").value;
            if (wsdlFile == undefined || wsdlFile == '') {
                CARBON.showWarningDialog('<fmt:message key="error.selectWSDL"/>');
            } else if (".wsdl" != wsdlFile.substring(wsdlFile.length-5)) {
                CARBON.showWarningDialog('<fmt:message key="error.selectWSDL"/>');
                return false;
            }
            else {
                submitFormAsync();
            }
        }

        function submitUsingURL() {
            var wsdlURL = document.getElementById("wsdlURL");
            if (wsdlURL.value == '' || !((wsdlURL.value.indexOf('http://') >= 0) || (wsdlURL.value.indexOf('https://') >= 0))) {
                CARBON.showWarningDialog('<fmt:message key="error.enterWSDLURL"/>');
            } else {
                startConvertWSDLUsingURL(wsdlURL.value);
            }
        }

        function startConvertWSDLUsingURL(url) {
            var bodyXML = '<req:convertWSDLUsingURL xmlns:req="http://wsdlconverter.carbon.wso2.org">' +
                          '<url>' + url + '</url>' +
                          '</req:convertWSDLUsingURL>';
            var generate_button = document.getElementById("convertWSDLUsingURL");
            generate_button.disabled = true;
            generate_button = document.getElementById("convertWSDLUsingFile");
            generate_button.disabled = true;
            var callURL = frondendURL + "WSDLConverterService/convertWSDLUsingURL" ;
            wso2.wsf.Util.cursorWait();
            new wso2.wsf.WSRequest(callURL, "urn:convertWSDLUsingURL", bodyXML, wsdlConverterCallback, [], wsdlConverterOnErrorCallback);
        }

        function startConvertWSDLUsingFile(uuid) {
            var bodyXML = '<req:convertWSDLUsingFile xmlns:req="http://wsdlconverter.carbon.wso2.org">' +
                          '<uuid>' + uuid + '</uuid>' +
                          '</req:convertWSDLUsingFile>';
            var generate_button = document.getElementById("convertWSDLUsingURL");
            generate_button.disabled = true;
            generate_button = document.getElementById("convertWSDLUsingFile");
            generate_button.disabled = true;
            var callURL = frondendURL + "WSDLConverterService/convertWSDLUsingFile" ;
            wso2.wsf.Util.cursorWait();
            new wso2.wsf.WSRequest(callURL, "urn:convertWSDLUsingFile", bodyXML, wsdlConverterCallback, [], wsdlConverterOnErrorCallback);
        }

        function wsdlConverterOnErrorCallback() {
            var generate_button = document.getElementById("convertWSDLUsingURL");
            generate_button.disabled = false;
            generate_button = document.getElementById("convertWSDLUsingFile");
            generate_button.disabled = false;
            this.defaultError.call(this);
        }

        function wsdlConverterCallback() {
            var data = this.req.responseXML;
            var responseTextValue = getResponseValue(data);
            var generate_button = document.getElementById("convertWSDLUsingURL");
            generate_button.disabled = false;
            generate_button = document.getElementById("convertWSDLUsingFile");
            generate_button.disabled = false;
            window.open(responseTextValue);
        }

        function getResponseValue(responseXML) {
            var returnElementList = responseXML.getElementsByTagName("ns:return");
            // Older browsers might not recognize namespaces (e.g. FF2)
            if (returnElementList.length == 0)
                returnElementList = responseXML.getElementsByTagName("return");
            var returnElement = returnElementList[0];

            return returnElement.firstChild.nodeValue;
        }


        var callback =
        {
            upload:handleUpload
        };

        function handleUpload(o) {
            var responseText = o.responseText;
            if (responseText) {
                var index = responseText.indexOf("<pre>");
                if (index < 0)
                    index = responseText.indexOf("<PRE>");
                var endIndex = responseText.indexOf("</pre>");
                if (endIndex < 0)
                    endIndex = responseText.indexOf("</PRE>");
                var uuid ='';
                if (index < 0)
                    uuid = responseText;
                else
                    uuid = responseText.substring(index + 5, endIndex);
                startConvertWSDLUsingFile(uuid);
            } else {
                CARBON.showWarningDialog('<fmt:message key="error.fileUploadFailed"/>');
            }
        }

        function submitFormAsync() {
            var form = document.getElementById("form");
            YAHOO.util.Connect.setForm(form, true, true);
            YAHOO.util.Connect.asyncRequest("POST", form.getAttribute("action"), callback, null);
        }
    </script>

    <div id="middle">
        <h2><fmt:message key="wsdlConverter"/></h2>

        <div style="padding-top:10px;padding-bottom:10px"><p><fmt:message key="tool.tip"/></p></div>

        <div id="workArea">
            <form id="form" method="post" enctype="multipart/form-data"
                  action="../../fileupload/tools">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="selectWSDLFromFile"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRow">
                            <table class="normal">
                                <tr>
                                    <td style="width:100px">
                                        <label><fmt:message key="selectWSDL"/></label>
                                    </td>
                                    <td>
                                        <input type="file" id="wsdlFile" name="wsdlFile"
                                               size="50"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input type="button" class="button"
                                   value='<fmt:message key="convertWSDL"/>'
                                   onclick="submitUsingFile();"
                                   id="convertWSDLUsingFile"/>
                        </td>
                    </tr>
                </table>
            </form>

            <br/>

            <table class="styledLeft">
                <thead>
                <tr>
                    <th><fmt:message key="enterWSDLURL"/></th>
                </tr>
                </thead>
                <tr>
                    <td class="formRow">
                        <table class="normal">
                            <tr>
                                <td style="width:100px;">
                                    <label><fmt:message key="enterURL"/></label>
                                </td>
                                <td>
                                    <input type="text" id="wsdlURL" name="wsdlURL"
                                           size="50"/>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td class="buttonRow">
                        <input type="button" class="button"
                               value='<fmt:message key="convertWSDL"/>'
                               onclick="submitUsingURL();"
                               id="convertWSDLUsingURL"/>
                    </td>
                </tr>
            </table>
            <div style="padding-top:20px">
                <fmt:message key="limitation.message"/>
            </div>
        </div>
    </div>
</fmt:bundle>
